open Compare_dec
open CoqList
open Datatypes
open Specif

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type 'domain comparison =
  | LESS
  | EQUAL
  | GREATER

(** val comparison_rect : 'a1 -> 'a1 -> (__ -> __ -> 'a2) -> (__ -> __ ->
                          'a2) -> (__ -> __ -> 'a2) -> 'a1 comparison -> 'a2 **)

let comparison_rect x y f f0 f1 = function
  | LESS -> f __ __
  | EQUAL -> f0 __ __
  | GREATER -> f1 __ __

(** val comparison_rec : 'a1 -> 'a1 -> (__ -> __ -> 'a2) -> (__ -> __ -> 'a2)
                         -> (__ -> __ -> 'a2) -> 'a1 comparison -> 'a2 **)

let comparison_rec x y f f0 f1 = function
  | LESS -> f __ __
  | EQUAL -> f0 __ __
  | GREATER -> f1 __ __

module type ORDERED_SET = 
 sig 
  type t 
  
  val compare : t -> t -> t comparison
 end

module Natural_numbers = 
 struct 
  type t = int
  
  (** val compare : int -> int -> t comparison **)
  
  let compare n m =
    match ( <= ) n m with
      | true -> (match ( <= ) m n with
                   | true -> EQUAL
                   | false -> LESS)
      | false -> GREATER
 end

module Lexicographic = 
 functor (A:ORDERED_SET) ->
 functor (B:ORDERED_SET) ->
 struct 
  type t = (A.t, B.t) pair
  
  (** val compare : t -> t -> t comparison **)
  
  let compare x y =
    let  (xa, xb) = x in
    let  (ya, yb) = y in
    (match A.compare xa ya with
       | LESS -> LESS
       | EQUAL ->
           (match B.compare xb yb with
              | LESS -> LESS
              | EQUAL -> EQUAL
              | GREATER -> GREATER)
       | GREATER -> GREATER)
 end

module LexicographicList = 
 functor (A:ORDERED_SET) ->
 struct 
  type t = A.t list
  
  (** val compare : t -> t -> t comparison **)
  
  let rec compare l y =
    match l with
      | Coq_nil ->
          (match y with
             | Coq_nil -> EQUAL
             | Coq_cons (hy, ty) -> LESS)
      | Coq_cons (a, l0) ->
          (match y with
             | Coq_nil -> GREATER
             | Coq_cons (hy, ty) ->
                 (match A.compare a hy with
                    | LESS -> LESS
                    | EQUAL ->
                        (match compare l0 ty with
                           | LESS -> LESS
                           | EQUAL -> EQUAL
                           | GREATER -> GREATER)
                    | GREATER -> GREATER))
 end

