open Compare_dec
open CoqList
open Datatypes
open Specif

type __ = Obj.t

type 'domain comparison =
  | LESS
  | EQUAL
  | GREATER

val comparison_rect :
  'a1 -> 'a1 -> (__ -> __ -> 'a2) -> (__ -> __ -> 'a2) -> (__ -> __ -> 'a2)
  -> 'a1 comparison -> 'a2

val comparison_rec :
  'a1 -> 'a1 -> (__ -> __ -> 'a2) -> (__ -> __ -> 'a2) -> (__ -> __ -> 'a2)
  -> 'a1 comparison -> 'a2

module type ORDERED_SET = 
 sig 
  type t 
  
  val compare : t -> t -> t comparison
 end

module Natural_numbers : 
 sig 
  type t = int
  
  val compare : int -> int -> t comparison
 end

module Lexicographic : 
 functor (A:ORDERED_SET) ->
 functor (B:ORDERED_SET) ->
 sig 
  type t = (A.t, B.t) pair
  
  val compare : t -> t -> t comparison
 end

module LexicographicList : 
 functor (A:ORDERED_SET) ->
 sig 
  type t = A.t list
  
  val compare : t -> t -> t comparison
 end

