open Datatypes
open Specif

type 'a list =
  | Coq_nil
  | Coq_cons of 'a * 'a list

val list_rect : 'a2 -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2

val list_rec : 'a2 -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2

val app : 'a1 list -> 'a1 list -> 'a1 list

val head : 'a1 list -> 'a1 option

val tail : 'a1 list -> 'a1 list

val length : 'a1 list -> int

val coq_In_dec : ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 list -> bool

val nth : int -> 'a1 list -> 'a1 -> 'a1

val nth_ok : int -> 'a1 list -> 'a1 -> bool

val nth_in_or_default : int -> 'a1 list -> 'a1 -> bool

val nth_error : 'a1 list -> int -> 'a1 coq_Exc

val nth_default : 'a1 -> 'a1 list -> int -> 'a1

val list_eq_dec : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool

val rev : 'a1 list -> 'a1 list

val map : ('a1 -> 'a2) -> 'a1 list -> 'a2 list

val flat_map : ('a1 -> 'a2 list) -> 'a1 list -> 'a2 list

val list_prod : 'a1 list -> 'a2 list -> ('a1, 'a2) pair list

val list_power : 'a1 list -> 'a2 list -> ('a1, 'a2) pair list list

val fold_left : ('a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> 'a1

val fold_right : ('a2 -> 'a1 -> 'a1) -> 'a1 -> 'a2 list -> 'a1

