type ('a, 'b) pair = 'a * 'b
val unit_rect : 'a1 -> unit -> 'a1

val unit_rec : 'a1 -> unit -> 'a1

val bool_rect : 'a1 -> 'a1 -> bool -> 'a1

val bool_rec : 'a1 -> 'a1 -> bool -> 'a1

val nat_rect : 'a1 -> (int -> 'a1 -> 'a1) -> int -> 'a1

val nat_rec : 'a1 -> (int -> 'a1 -> 'a1) -> int -> 'a1

type coq_Empty_set = unit (* empty inductive *)

val coq_Empty_set_rect : coq_Empty_set -> 'a1

val coq_Empty_set_rec : coq_Empty_set -> 'a1

type 'a identity =
  | Coq_refl_identity

val identity_rect : 'a1 -> 'a2 -> 'a1 -> 'a1 identity -> 'a2

val identity_rec : 'a1 -> 'a2 -> 'a1 -> 'a1 identity -> 'a2

val option_rect : ('a1 -> 'a2) -> 'a2 -> 'a1 option -> 'a2

val option_rec : ('a1 -> 'a2) -> 'a2 -> 'a1 option -> 'a2

type ('a, 'b) sum =
  | Coq_inl of 'a
  | Coq_inr of 'b

val sum_rect : ('a1 -> 'a3) -> ('a2 -> 'a3) -> ('a1, 'a2) sum -> 'a3

val sum_rec : ('a1 -> 'a3) -> ('a2 -> 'a3) -> ('a1, 'a2) sum -> 'a3

val prod_rect : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) pair -> 'a3

val prod_rec : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) pair -> 'a3

val fst : ('a1, 'a2) pair -> 'a1

val snd : ('a1, 'a2) pair -> 'a2

type comparison =
  | Eq
  | Lt
  | Gt

val comparison_rect : 'a1 -> 'a1 -> 'a1 -> comparison -> 'a1

val comparison_rec : 'a1 -> 'a1 -> 'a1 -> comparison -> 'a1

val coq_CompOpp : comparison -> comparison

