open Datatypes
open Computable_total_ordering

module Functional_maps = 
 functor (Domain:Computable_total_ordering.ORDERED_SET) ->
 struct 
  type domain = Domain.t
  
  (** val func_add : domain -> 'a1 -> (domain -> 'a1 option) -> domain -> 'a1
                     option **)
  
  let func_add key img f lookup =
    match Domain.compare lookup key with
      | LESS -> f lookup
      | EQUAL -> Some img
      | GREATER -> f lookup
  
  (** val func_remove : domain -> (domain -> 'a1 option) -> domain -> 'a1
                        option **)
  
  let func_remove key f lookup =
    match Domain.compare key lookup with
      | LESS -> f lookup
      | EQUAL -> None
      | GREATER -> f lookup
 end

module type ABSTRACT_MAP = 
 sig 
  module Domain : 
   Computable_total_ordering.ORDERED_SET
  
  type 'x t 
  
  val empty : unit -> 'a1 t
  
  val find : Domain.t -> 'a1 t -> 'a1 option
  
  val add : Domain.t -> 'a1 -> 'a1 t -> 'a1 t
  
  val func_add :
    Domain.t -> 'a1 -> (Domain.t -> 'a1 option) -> Domain.t -> 'a1 option
  
  val remove : Domain.t -> 'a1 t -> 'a1 t
  
  val func_remove :
    Domain.t -> (Domain.t -> 'a1 option) -> Domain.t -> 'a1 option
  
  val mapi1_opt : (Domain.t -> 'a1 -> 'a2 option) -> 'a1 t -> 'a2 t
  
  val func_mapi1_opt :
    (Domain.t -> 'a1 -> 'a2 option) -> (Domain.t -> 'a1 option) -> Domain.t
    -> 'a2 option
  
  val func_mapi2_opt :
    (Domain.t -> 'a1 -> 'a3 option) -> (Domain.t -> 'a2 -> 'a3 option) ->
    (Domain.t -> 'a1 -> 'a2 -> 'a3 option) -> (Domain.t -> 'a1 option) ->
    (Domain.t -> 'a2 option) -> Domain.t -> 'a3 option
  
  val mapi2_opt :
    (Domain.t -> 'a1 -> 'a3 option) -> (Domain.t -> 'a2 -> 'a3 option) ->
    (Domain.t -> 'a1 -> 'a2 -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
 end

